Index: LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2298)
@@ -559,606 +274,84 @@
      sollwdown(:)=sollw(:)+RSIGMA*zts(:)**4
   ENDIF
-!  print*,'TS SOLL',zts(klon/2),sollw(klon/2),sollwdown(klon/2)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(sollwdown(i), xmin)
-     xmax = MAX(sollwdown(i), xmax)
-  ENDDO
-  PRINT*, 'Rayonnement IF au sol sollwdown:', xmin, xmax
-
-
-  ! Lecture derive des flux:
-
-  CALL get_field("fder", fder, found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <fder> est absent'
-     PRINT*, 'mis a zero'
-     fder = 0.
+
+  found=phyetat0_get(1,radsol,"RADS","Solar radiation",0.)
+  found=phyetat0_get(1,fder,"fder","Flux derivative",0.) 
+
+
+  ! Lecture de la longueur de rugosite 
+  found=phyetat0_srf(1,z0m,"RUG","Z0m ancien",0.001)
+  IF (found) THEN
+     z0h(:,1:nbsrf)=z0m(:,1:nbsrf)
+  ELSE
+     found=phyetat0_srf(1,z0m,"Z0m","Roughness length, momentum ",0.001)
+     found=phyetat0_srf(1,z0h,"Z0h","Roughness length, enthalpy ",0.001)
   ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(fder(i), xmin)
-     xmax = MAX(fder(i), xmax)
-  ENDDO
-  PRINT*, 'Derive des flux fder:', xmin, xmax
-
-  ! Lecture du rayonnement net au sol:
-
-  CALL get_field("RADS", radsol)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(radsol(i), xmin)
-     xmax = MAX(radsol(i), xmax)
-  ENDDO
-  PRINT*, 'Rayonnement net au sol radsol:', xmin, xmax
-
-  ! Lecture de la longueur de rugosite 
-
-  CALL get_field("RUG", frugs(:, 1), found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <RUG> est absent'
-     PRINT*, '          Mais je vais essayer de lire RUG**'
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field("RUG"//str2, frugs(:, nsrf))
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon
-           xmin = MIN(frugs(i, nsrf), xmin)
-           xmax = MAX(frugs(i, nsrf), xmax)
-        ENDDO
-        PRINT*, 'rugosite du sol RUG**:', nsrf, xmin, xmax
-     ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <RUG> est present'
-     PRINT*, '          J ignore donc les autres RUG**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(frugs(i, 1), xmin)
-        xmax = MAX(frugs(i, 1), xmax)
-     ENDDO
-     PRINT*, 'rugosite <RUG>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           frugs(i, nsrf) = frugs(i, 1)
-        ENDDO
-     ENDDO
+
+  ! Lecture de l'age de la neige:
+  found=phyetat0_srf(1,agesno,"AGESNO","SNOW AGE",0.001)
+
+  ancien_ok=.true.
+  ancien_ok=ancien_ok.AND.phyetat0_get(klev,t_ancien,"TANCIEN","TANCIEN",0.)
+  ancien_ok=ancien_ok.AND.phyetat0_get(klev,q_ancien,"QANCIEN","QANCIEN",0.)
+  ancien_ok=ancien_ok.AND.phyetat0_get(klev,u_ancien,"UANCIEN","UANCIEN",0.)
+  ancien_ok=ancien_ok.AND.phyetat0_get(klev,v_ancien,"VANCIEN","VANCIEN",0.)
+
+  found=phyetat0_get(klev,clwcon,"CLWCON","CLWCON",0.)
+  found=phyetat0_get(klev,rnebcon,"RNEBCON","RNEBCON",0.)
+  found=phyetat0_get(klev,ratqs,"RATQS","RATQS",0.)
+
+  found=phyetat0_get(1,run_off_lic_0,"RUNOFFLIC0","RUNOFFLIC0",0.)
+
+!==================================
+!  TKE
+!==================================
+!
+  IF (iflag_pbl>1) then
+     found=phyetat0_srf(klev+1,pbl_tke,"TKE","Turb. Kinetic. Energ. ",1.e-8)
   ENDIF
 
-  ! Lecture de l'age de la neige:
-
-  CALL get_field("AGESNO", agesno(:, 1), found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <AGESNO> est absent'
-     PRINT*, '          Mais je vais essayer de lire AGESNO**'
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field("AGESNO"//str2, agesno(:, nsrf), found)
-        IF (.NOT. found) THEN
-           PRINT*, "phyetat0: Le champ <AGESNO"//str2//"> est absent"
-           agesno = 50.0
-        ENDIF
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon
-           xmin = MIN(agesno(i, nsrf), xmin)
-           xmax = MAX(agesno(i, nsrf), xmax)
-        ENDDO
-        PRINT*, 'Age de la neige AGESNO**:', nsrf, xmin, xmax
-     ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <AGESNO> est present'
-     PRINT*, '          J ignore donc les autres AGESNO**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(agesno(i, 1), xmin)
-        xmax = MAX(agesno(i, 1), xmax)
-     ENDDO
-     PRINT*, 'Age de la neige <AGESNO>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           agesno(i, nsrf) = agesno(i, 1)
-        ENDDO
-     ENDDO
-  ENDIF
-
-  CALL get_field("ZMEA", zmea)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(zmea(i), xmin)
-     xmax = MAX(zmea(i), xmax)
-  ENDDO
-  PRINT*, 'OROGRAPHIE SOUS-MAILLE zmea:', xmin, xmax
-
-  CALL get_field("ZSTD", zstd)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(zstd(i), xmin)
-     xmax = MAX(zstd(i), xmax)
-  ENDDO
-  PRINT*, 'OROGRAPHIE SOUS-MAILLE zstd:', xmin, xmax
-
-  CALL get_field("ZSIG", zsig)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(zsig(i), xmin)
-     xmax = MAX(zsig(i), xmax)
-  ENDDO
-  PRINT*, 'OROGRAPHIE SOUS-MAILLE zsig:', xmin, xmax
-
-  CALL get_field("ZGAM", zgam)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(zgam(i), xmin)
-     xmax = MAX(zgam(i), xmax)
-  ENDDO
-  PRINT*, 'OROGRAPHIE SOUS-MAILLE zgam:', xmin, xmax
-
-  CALL get_field("ZTHE", zthe)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(zthe(i), xmin)
-     xmax = MAX(zthe(i), xmax)
-  ENDDO
-  PRINT*, 'OROGRAPHIE SOUS-MAILLE zthe:', xmin, xmax
-
-  CALL get_field("ZPIC", zpic)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(zpic(i), xmin)
-     xmax = MAX(zpic(i), xmax)
-  ENDDO
-  PRINT*, 'OROGRAPHIE SOUS-MAILLE zpic:', xmin, xmax
-
-  CALL get_field("ZVAL", zval)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(zval(i), xmin)
-     xmax = MAX(zval(i), xmax)
-  ENDDO
-  PRINT*, 'OROGRAPHIE SOUS-MAILLE zval:', xmin, xmax
-
-  CALL get_field("RUGSREL", rugoro)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(rugoro(i), xmin)
-     xmax = MAX(rugoro(i), xmax)
-  ENDDO
-  PRINT*, 'Rugosite relief (ecart-type) rugsrel:', xmin, xmax
-
-  ancien_ok = .TRUE.
-
-  CALL get_field("TANCIEN", t_ancien, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <TANCIEN> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     ancien_ok = .FALSE.
-  ENDIF
-
-  CALL get_field("QANCIEN", q_ancien, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <QANCIEN> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     ancien_ok = .FALSE.
-  ENDIF
-
-  CALL get_field("UANCIEN", u_ancien, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <UANCIEN> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     ancien_ok = .FALSE.
-  ENDIF
-
-  CALL get_field("VANCIEN", v_ancien, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <VANCIEN> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     ancien_ok = .FALSE.
-  ENDIF
-
-  clwcon=0.
-  CALL get_field("CLWCON", clwcon, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ CLWCON est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(clwcon)
-  xmax = MAXval(clwcon)
-  PRINT*, 'Eau liquide convective (ecart-type) clwcon:', xmin, xmax
-
-  rnebcon = 0.
-  CALL get_field("RNEBCON", rnebcon, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ RNEBCON est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(rnebcon)
-  xmax = MAXval(rnebcon)
-  PRINT*, 'Nebulosite convective (ecart-type) rnebcon:', xmin, xmax
-
-  ! Lecture ratqs
-
-  ratqs=0.
-  CALL get_field("RATQS", ratqs, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <RATQS> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(ratqs)
-  xmax = MAXval(ratqs)
-  PRINT*, '(ecart-type) ratqs:', xmin, xmax
-
-  ! Lecture run_off_lic_0
-
-  CALL get_field("RUNOFFLIC0", run_off_lic_0, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <RUNOFFLIC0> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     run_off_lic_0 = 0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(run_off_lic_0)
-  xmax = MAXval(run_off_lic_0)
-  PRINT*, '(ecart-type) run_off_lic_0:', xmin, xmax
-
-  ! Lecture de l'energie cinetique turbulente
-
-  IF (iflag_pbl>1) then
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field("TKE"//str2, pbl_tke(:, 1:klev+1, nsrf), found)
-        IF (.NOT. found) THEN
-           PRINT*, "phyetat0: <TKE"//str2//"> est absent"
-           pbl_tke(:, :, nsrf)=1.e-8
-        ENDIF
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO k = 1, klev+1
-           DO i = 1, klon
-              xmin = MIN(pbl_tke(i, k, nsrf), xmin)
-              xmax = MAX(pbl_tke(i, k, nsrf), xmax)
-           ENDDO
-        ENDDO
-        PRINT*, 'Turbulent kinetic energyl TKE**:', nsrf, xmin, xmax
-     ENDDO
-  ENDIF
-
-! Lecture de l'ecart de TKE (w) - (x)
-!
-  IF (iflag_pbl>1 .AND. iflag_wake>=1  &
-           .AND. iflag_pbl_split >=1 ) then
-    DO nsrf = 1, nbsrf
-      IF (nsrf.GT.99) THEN
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyetat0", "", 1)
-      ENDIF
-      WRITE(str2,'(i2.2)') nsrf
-      CALL get_field("DELTATKE"//str2, &
-                    wake_delta_pbl_tke(:,1:klev+1,nsrf),found)
-      IF (.NOT. found) THEN
-        PRINT*, "phyetat0: <DELTATKE"//str2//"> est absent"
-        wake_delta_pbl_tke(:,:,nsrf)=0.
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO k = 1, klev+1
-        DO i = 1, klon
-          xmin = MIN(wake_delta_pbl_tke(i,k,nsrf),xmin)
-          xmax = MAX(wake_delta_pbl_tke(i,k,nsrf),xmax)
-        ENDDO
-      ENDDO
-      PRINT*,'TKE difference (w)-(x) DELTATKE**:', nsrf, xmin, xmax
-    ENDDO
-
-  ! delta_tsurf
-
-    DO nsrf = 1, nbsrf
-       IF (nsrf.GT.99) THEN
-         PRINT*, "Trop de sous-mailles"
-         call abort_gcm("phyetat0", "", 1)
-       ENDIF
-       WRITE(str2,'(i2.2)') nsrf
-     CALL get_field("DELTA_TSURF"//str2, delta_tsurf(:,nsrf), found)
-     IF (.NOT. found) THEN
-        PRINT*, "phyetat0: Le champ <DELTA_TSURF"//str2//"> est absent"
-        PRINT*, "Depart legerement fausse. Mais je continue"
-        delta_tsurf(:,nsrf)=0.
-     ELSE
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-         DO i = 1, klon
-            xmin = MIN(delta_tsurf(i, nsrf), xmin)
-            xmax = MAX(delta_tsurf(i, nsrf), xmax)
-         ENDDO
-        PRINT*, 'delta_tsurf:', xmin, xmax
-     ENDIF
-    ENDDO  ! nsrf = 1, nbsrf
+  IF (iflag_pbl>1 .AND. iflag_wake>=1  .AND. iflag_pbl_split >=1 ) then
+    found=phyetat0_srf(klev+1,wake_delta_pbl_tke,"DELTATKE","Del TKE wk/env",0.)
+    found=phyetat0_srf(1,delta_tsurf,"DELTA_TSURF","Delta Ts wk/env ",0.)
   ENDIF   !(iflag_pbl>1 .AND. iflag_wake>=1 .AND. iflag_pbl_split >=1 )
 
-  ! zmax0
-  CALL get_field("ZMAX0", zmax0, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <ZMAX0> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     zmax0=40.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(zmax0)
-  xmax = MAXval(zmax0)
-  PRINT*, '(ecart-type) zmax0:', xmin, xmax
-
-  !           f0(ig)=1.e-5
-  ! f0
-  CALL get_field("F0", f0, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <f0> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     f0=1.e-5
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(f0)
-  xmax = MAXval(f0)
-  PRINT*, '(ecart-type) f0:', xmin, xmax
-
-  ! sig1 or ema_work1
-
-  CALL get_field("sig1", sig1, found)
-  IF (.NOT. found) CALL get_field("EMA_WORK1", sig1, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ sig1 est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     sig1=0.
-  ELSE
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO k = 1, klev
-        DO i = 1, klon
-           xmin = MIN(sig1(i, k), xmin)
-           xmax = MAX(sig1(i, k), xmax)
-        ENDDO
-     ENDDO
-     PRINT*, 'sig1:', xmin, xmax
-  ENDIF
-
-  ! w01 or ema_work2
-
-  CALL get_field("w01", w01, found)
-  IF (.NOT. found) CALL get_field("EMA_WORK2", w01, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ w01 est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     w01=0.
-  ELSE
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO k = 1, klev
-        DO i = 1, klon
-           xmin = MIN(w01(i, k), xmin)
-           xmax = MAX(w01(i, k), xmax)
-        ENDDO
-     ENDDO
-     PRINT*, 'w01:', xmin, xmax
-  ENDIF
-
-  ! wake_deltat
-
-  CALL get_field("WAKE_DELTAT", wake_deltat, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <WAKE_DELTAT> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     wake_deltat=0.
-  ELSE
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO k = 1, klev
-        DO i = 1, klon
-           xmin = MIN(wake_deltat(i, k), xmin)
-           xmax = MAX(wake_deltat(i, k), xmax)
-        ENDDO
-     ENDDO
-     PRINT*, 'wake_deltat:', xmin, xmax
-  ENDIF
-
-  ! wake_deltaq
-
-  CALL get_field("WAKE_DELTAQ", wake_deltaq, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <WAKE_DELTAQ> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     wake_deltaq=0.
-  ELSE
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO k = 1, klev
-        DO i = 1, klon
-           xmin = MIN(wake_deltaq(i, k), xmin)
-           xmax = MAX(wake_deltaq(i, k), xmax)
-        ENDDO
-     ENDDO
-     PRINT*, 'wake_deltaq:', xmin, xmax
-  ENDIF
-
-  ! wake_s
-
-  CALL get_field("WAKE_S", wake_s, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <WAKE_S> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     wake_s=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(wake_s)
-  xmax = MAXval(wake_s)
-  PRINT*, '(ecart-type) wake_s:', xmin, xmax
-
-  ! wake_cstar
-
-  CALL get_field("WAKE_CSTAR", wake_cstar, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <WAKE_CSTAR> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     wake_cstar=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(wake_cstar)
-  xmax = MAXval(wake_cstar)
-  PRINT*, '(ecart-type) wake_cstar:', xmin, xmax
-
-  ! wake_pe
-
-  CALL get_field("WAKE_PE", wake_pe, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <WAKE_PE> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     wake_pe=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(wake_pe)
-  xmax = MAXval(wake_pe)
-  PRINT*, '(ecart-type) wake_pe:', xmin, xmax
-
-  ! wake_fip
-
-  CALL get_field("WAKE_FIP", wake_fip, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <WAKE_FIP> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     wake_fip=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(wake_fip)
-  xmax = MAXval(wake_fip)
-  PRINT*, '(ecart-type) wake_fip:', xmin, xmax
-
-  !  thermiques
-
-  CALL get_field("FM_THERM", fm_therm, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <fm_therm> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     fm_therm=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(fm_therm)
-  xmax = MAXval(fm_therm)
-  PRINT*, '(ecart-type) fm_therm:', xmin, xmax
-
-  CALL get_field("ENTR_THERM", entr_therm, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <entr_therm> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     entr_therm=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(entr_therm)
-  xmax = MAXval(entr_therm)
-  PRINT*, '(ecart-type) entr_therm:', xmin, xmax
-
-  CALL get_field("DETR_THERM", detr_therm, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <detr_therm> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     detr_therm=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(detr_therm)
-  xmax = MAXval(detr_therm)
-  PRINT*, '(ecart-type) detr_therm:', xmin, xmax
-
-  CALL get_field("ALE_BL", ale_bl, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <ale_bl> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     ale_bl=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(ale_bl)
-  xmax = MAXval(ale_bl)
-  PRINT*, '(ecart-type) ale_bl:', xmin, xmax
-
-  CALL get_field("ALE_BL_TRIG", ale_bl_trig, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <ale_bl_trig> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     ale_bl_trig=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(ale_bl_trig)
-  xmax = MAXval(ale_bl_trig)
-  PRINT*, '(ecart-type) ale_bl_trig:', xmin, xmax
-
-  CALL get_field("ALP_BL", alp_bl, found)
-  IF (.NOT. found) THEN
-     PRINT*, "phyetat0: Le champ <alp_bl> est absent"
-     PRINT*, "Depart legerement fausse. Mais je continue"
-     alp_bl=0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  xmin = MINval(alp_bl)
-  xmax = MAXval(alp_bl)
-  PRINT*, '(ecart-type) alp_bl:', xmin, xmax
-
+!==================================
+!  thermiques, poches, convection
+!==================================
+
+! Emanuel
+  found=phyetat0_get(klev,sig1,"sig1","sig1",0.)
+  found=phyetat0_get(klev,w01,"w01","w01",0.)
+
+! Wake
+  found=phyetat0_get(klev,wake_deltat,"WAKE_DELTAT","Delta T wake/env",0.)
+  found=phyetat0_get(klev,wake_deltaq,"WAKE_DELTAQ","Delta hum. wake/env",0.)
+  found=phyetat0_get(1,wake_s,"WAKE_S","WAKE_S",0.)
+  found=phyetat0_get(1,wake_cstar,"WAKE_CSTAR","WAKE_CSTAR",0.)
+  found=phyetat0_get(1,wake_pe,"WAKE_PE","WAKE_PE",0.)
+  found=phyetat0_get(1,wake_fip,"WAKE_FIP","WAKE_FIP",0.)
+
+! Thermiques
+  found=phyetat0_get(1,zmax0,"ZMAX0","ZMAX0",40.)
+  found=phyetat0_get(1,f0,"F0","F0",1.e-5)
+  found=phyetat0_get(klev+1,fm_therm,"FM_THERM","Thermals mass flux",0.)
+  found=phyetat0_get(klev,entr_therm,"ENTR_THERM","Thermals Entrain.",0.)
+  found=phyetat0_get(klev,detr_therm,"DETR_THERM","Thermals Detrain.",0.)
+
+! ALE/ALP
+  found=phyetat0_get(1,ale_bl,"ALE_BL","ALE BL",0.)
+  found=phyetat0_get(1,ale_bl_trig,"ALE_BL_TRIG","ALE BL_TRIG",0.)
+  found=phyetat0_get(1,alp_bl,"ALP_BL","ALP BL",0.)
+
+!===========================================
   ! Read and send field trs to traclmdz
+!===========================================
 
   IF (type_trac == 'lmdz') THEN
-     DO it=1, nbtr
-        iiq=niadv(it+2)
-        CALL get_field("trs_"//tname(iiq), trs(:, it), found)
-        IF (.NOT. found) THEN
-           PRINT*,  &
-                "phyetat0: Le champ <trs_"//tname(iiq)//"> est absent"
-           PRINT*, "Depart legerement fausse. Mais je continue"
-           trs(:, it) = 0.
-        ENDIF
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        xmin = MINval(trs(:, it))
-        xmax = MAXval(trs(:, it))
-        PRINT*, "(ecart-type) trs_"//tname(iiq)//" :", xmin, xmax
-
+     DO it=1, nbtr                                                                  
+!!        iiq=niadv(it+2)                                                           ! jyg
+        iiq=niadv(it+nqo)                                                           ! jyg
+        found=phyetat0_get(1,trs(:,it),"trs_"//tname(iiq), &
+              "Surf trac"//tname(iiq),0.)
      END DO
      CALL traclmdz_from_restart(trs)
@@ -1166,35 +359,37 @@
      IF (carbon_cycle_cpl) THEN
         ALLOCATE(co2_send(klon), stat=ierr)
-        IF (ierr /= 0) CALL abort_gcm &
-             ('phyetat0', 'pb allocation co2_send', 1)
-        CALL get_field("co2_send", co2_send, found)
-        IF (.NOT. found) THEN
-           PRINT*, "phyetat0: Le champ <co2_send> est absent"
-           PRINT*, "Initialisation uniforme a co2_ppm=", co2_ppm
-           co2_send(:) = co2_ppm
-        END IF
+        IF (ierr /= 0) CALL abort_gcm('phyetat0', 'pb allocation co2_send', 1)
+        found=phyetat0_get(1,co2_send,"co2_send","co2 send",0.)
      END IF
   END IF
 
+!===========================================
+!  ondes de gravite / relief
+!===========================================
+
+!  ondes de gravite non orographiques
   if (ok_gwd_rando) then
-     call get_field("du_gwd_rando", du_gwd_rando, found)
-     if (.not. found) then
-        print *, "du_gwd_rando not found, setting it to 0."
-        du_gwd_rando = 0.
-     end if
-
-     call get_field("dv_gwd_rando", dv_gwd_rando, found)
-     if (.not. found) then
-        print *, "dv_gwd_rando not found, setting it to 0."
-        dv_gwd_rando = 0.
-     end if
+     found=phyetat0_get(klev,du_gwd_rando,"du_gwd_rando","du_gwd_rando",0.)
+     found=phyetat0_get(klev,dv_gwd_rando,"dv_gwd_rando","dv_gwd_rando",0.)
   end if
 
-  ! Initialize Slab variables
+!  prise en compte du relief sous-maille
+  found=phyetat0_get(1,zmea,"ZMEA","sub grid orography",0.)
+  found=phyetat0_get(1,zstd,"ZSTD","sub grid orography",0.)
+  found=phyetat0_get(1,zsig,"ZSIG","sub grid orography",0.)
+  found=phyetat0_get(1,zgam,"ZGAM","sub grid orography",0.)
+  found=phyetat0_get(1,zthe,"ZTHE","sub grid orography",0.)
+  found=phyetat0_get(1,zpic,"ZPIC","sub grid orography",0.)
+  found=phyetat0_get(1,zval,"ZVAL","sub grid orography",0.)
+  found=phyetat0_get(1,zmea,"ZMEA","sub grid orography",0.)
+  found=phyetat0_get(1,rugoro,"RUGSREL","sub grid orography",0.)
+
+!===========================================
+! Initialize ocean
+!===========================================
+
   IF ( type_ocean == 'slab' ) THEN
-      print*, "calling slab_init"
       CALL ocean_slab_init(dtime, pctsrf)
-      ! tslab
-      CALL get_field("tslab", tslab, found)
+      found=phyetat0_get(nslay,tslab,"tslab","tslab",0.)
       IF (.NOT. found) THEN 
           PRINT*, "phyetat0: Le champ <tslab> est absent"
@@ -1204,7 +399,8 @@
           END DO
       END IF 
+
       ! Sea ice variables
+      found=phyetat0_get(1,tice,"slab_tice","slab_tice",0.)
       IF (version_ocean == 'sicINT') THEN
-          CALL get_field("slab_tice", tice, found)
           IF (.NOT. found) THEN 
               PRINT*, "phyetat0: Le champ <tice> est absent"
@@ -1212,5 +408,4 @@
                   tice(:)=ftsol(:,is_sic)
           END IF 
-          CALL get_field("seaice", seaice, found)
           IF (.NOT. found) THEN
               PRINT*, "phyetat0: Le champ <seaice> est absent"
@@ -1229,6 +424,5 @@
   ! Initialize module pbl_surface_mod 
 
-  CALL pbl_surface_init(qsol, fder, snow, qsurf, &
-       evap, frugs, agesno, tsoil)
+  CALL pbl_surface_init(fder, snow, qsurf, tsoil)
 
   ! Initialize module ocean_cpl_mod for the case of coupled ocean
@@ -1243,2 +437,85 @@
 
 END SUBROUTINE phyetat0
+
+!===================================================================
+FUNCTION phyetat0_get(nlev,field,name,descr,default)
+!===================================================================
+! Lecture d'un champ avec contrôle
+! Function logique dont le resultat indique si la lecture
+! s'est bien passée
+! On donne une valeur par defaut dans le cas contraire
+!===================================================================
+
+USE iostart, ONLY : get_field
+USE dimphy, only: klon 
+
+IMPLICIT NONE
+INCLUDE "iniprint.h"
+
+LOGICAL phyetat0_get
+
+! arguments
+INTEGER,INTENT(IN) :: nlev
+CHARACTER*(*),INTENT(IN) :: name,descr
+REAL,INTENT(IN) :: default
+REAL,DIMENSION(klon,nlev),INTENT(INOUT) :: field
+
+! Local variables
+LOGICAL found
+
+   CALL get_field(name, field, found)
+   IF (.NOT. found) THEN
+     WRITE(lunout,*) "phyetat0: Le champ <",name,"> est absent"
+     WRITE(lunout,*) "Depart legerement fausse. Mais je continue"
+     field(:,:)=default
+   ENDIF
+   WRITE(lunout,*) name, descr, MINval(field),MAXval(field)
+   phyetat0_get=found
+
+RETURN
+END FUNCTION phyetat0_get
+
+!================================================================
+FUNCTION phyetat0_srf(nlev,field,name,descr,default)
+!===================================================================
+! Lecture d'un champ par sous-surface avec contrôle
+! Function logique dont le resultat indique si la lecture
+! s'est bien passée
+! On donne une valeur par defaut dans le cas contraire
+!===================================================================
+
+USE iostart, ONLY : get_field
+USE dimphy, only: klon 
+USE indice_sol_mod, only: nbsrf
+
+IMPLICIT NONE
+INCLUDE "iniprint.h"
+
+LOGICAL phyetat0_srf
+! arguments
+INTEGER,INTENT(IN) :: nlev
+CHARACTER*(*),INTENT(IN) :: name,descr
+REAL,INTENT(IN) :: default
+REAL,DIMENSION(klon,nlev,nbsrf),INTENT(INOUT) :: field
+
+! Local variables
+LOGICAL found,phyetat0_get
+INTEGER nsrf
+CHARACTER*2 str2
+  
+     IF (nbsrf.GT.99) THEN
+        WRITE(lunout,*) "Trop de sous-mailles"
+        call abort_gcm("phyetat0", "", 1)
+     ENDIF
+
+     DO nsrf = 1, nbsrf
+        WRITE(str2, '(i2.2)') nsrf
+        found= phyetat0_get(nlev,field(:,:, nsrf), &
+        name//str2,descr//" srf:"//str2,default)
+     ENDDO
+
+     phyetat0_srf=found
+
+RETURN
+END FUNCTION phyetat0_srf
+
Index: LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2298)
@@ -36,10 +36,6 @@
   REAL tsoil(klon, nsoilmx, nbsrf)
   REAL qsurf(klon, nbsrf)
-  REAL qsol(klon)
   REAL snow(klon, nbsrf)
-  REAL evap(klon, nbsrf)
   real fder(klon)
-  REAL frugs(klon, nbsrf)
-  REAL agesno(klon, nbsrf)
   REAL run_off_lic_0(klon)
   REAL trs(klon, nbtr)
@@ -60,6 +56,5 @@
   ! Get variables which will be written to restart file from module 
   ! pbl_surface_mod
-  CALL pbl_surface_final(qsol, fder, snow, qsurf,  &
-       evap, frugs, agesno, tsoil)
+  CALL pbl_surface_final(fder, snow, qsurf,  tsoil)
 
   ! Get a variable calculated in module fonte_neige_mod
@@ -190,28 +185,6 @@
      IF (nsrf.LE.99) THEN
         WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("ALBE"//str2, "albedo de surface No."//str2, &
-             falb1(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  ENDDO
-
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("ALBLW"//str2, "albedo LW de surface No."//str2, &
-             falb2(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  ENDDO
-
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
         CALL put_field("EVAP"//str2, "Evaporation de surface No."//str2 &
-             , evap(:, nsrf))
+             , fevap(:, nsrf))
      ELSE
         PRINT*, "Trop de sous-mailles"
@@ -248,6 +221,8 @@
      IF (nsrf.LE.99) THEN
         WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("RUG"//str2, "rugosite de surface No."//str2, &
-             frugs(:, nsrf))
+        CALL put_field("Z0m"//str2, "rugosite de surface No."//str2, &
+             z0m(:, nsrf))
+        CALL put_field("Z0h"//str2, "rugosite de surface No."//str2, &
+             z0h(:, nsrf))
      ELSE
         PRINT*, "Trop de sous-mailles"
@@ -291,7 +266,4 @@
 
   CALL put_field("VANCIEN", "", v_ancien)
-
-  CALL put_field("RUGMER", "Longueur de rugosite sur mer", &
-       frugs(:, is_oce))
 
   CALL put_field("CLWCON", "Eau liquide convective", clwcon)
@@ -313,4 +285,6 @@
            CALL put_field("TKE"//str2, "Energ. Cineti. Turb."//str2, &
                 pbl_tke(:, 1:klev+1, nsrf))
+           CALL put_field("DELTATKE"//str2, "Del TKE wk/env."//str2, &
+                wake_delta_pbl_tke(:, 1:klev+1, nsrf))
         ELSE
            PRINT*, "Trop de sous-mailles"
@@ -363,5 +337,6 @@
      CALL traclmdz_to_restart(trs)
      DO it=1, nbtr
-        iiq=niadv(it+2)
+!!        iiq=niadv(it+2)                                                           ! jyg
+        iiq=niadv(it+nqo)                                                           ! jyg
         CALL put_field("trs_"//tname(iiq), "", trs(:, it))
      END DO
